<div class="panelHeader">
	<div class="refreshToolbar">
		<span class="lastUpdated"></span>
	</div>
	<% if (associatedPlatform) { %>
		<div class="navLink">
			${linkTo(l.getFormattedMessage("link.goto.associated.platform.page", associatedPlatform.name), [resource:associatedPlatform])}
		</div>
	<% } %>
</div>
<% if (errorMessage) { %>
	<div id="chartSettings"class="notification">
		<strong>${l.getFormattedMessage('text.unable.to.retreive.performance.data.for', resource.name)}</strong><% if (canViewResource) { %>&nbsp;&nbsp;<span class='navLink'>(${linkTo(l['link.view.resource'], [resource:resource])})</span><% } %><br/><br/>
		<div class="warning">${errorMessage}</div>
	</div>
<% } else { %>
	<div id="chartSettings">
		<strong>${l.getFormattedMessage('text.performance.data.for', resource.name)}</strong><% if (canViewResource) { %>&nbsp;&nbsp;<span class='navLink'>(${linkTo(l['link.view.resource'], [resource:resource])})</span><% } %><br/><br/>
		<span>${l['label.date.range']}</span>
		<select id="rangeSelection">
  			<option value="3600000">${l['text.one.hour']}</option>
	  		<option value="14400000">${l['text.four.hours']}</option>
  			<option value="43200000" selected="true">${l['text.twelve.hours']}</option>
	  		<option value="86400000">${l['text.one.day']}</option>
  			<option value="172800000">${l['text.two.days']}</option>
	  		<option value="604800000">${l['text.one.week']}</option>
  			<option value="2419200000">${l['text.one.month']}</option>
		</select>
		<% if (host && hostMetrics) { %>
			<span style="margin-left:15px;">${l['label.compare.metric']}</span>
			<select id="metricSelection">
	  			<option value="0">${l['text.none']}</option>
	  			<% if (!vm) { %>
	  				<option value="-1">${host.name.replaceFirst(/ \{.*\}/, '...')} - ${l['text.all.metrics']}</option>
  				<% }	
			   	
			   	for (m in hostMetrics) { %>
  			    	<option value="${m['id']}" class="hostMetric">${host.name.replaceFirst(/ \{.*\}/, '...')} - ${m['name']}</option>
  				<% }
  			   	
  			   	if (vmMetrics) { 
					for (m in vmMetrics) { %>
  			        	<option value="${m['id']}" class="vmMetric">${vm.name.replaceFirst(/ \{.*\}/, '...')} - ${m['name']}</option>
  			   		<% }
  			   	} %>
			</select>
		<% } %>
	</div>
	<div id="availability" style="padding: 0 30px;"></div>
	<div id="charts">
	  	<% for (metric in resourceMetrics) { %>
  			<div id="chart${metric.id}" class="chartcontainer"></div>
  		<% } %>
	</div>

	<script type="text/javascript">
		function performance_SelectNode(id) {
			jQuery("#tree-inventory").trigger("selectNode", id);
		};

		function percentFormatter(val, axis) {
			if (axis) {
				return val.toFixed(axis.tickDecimals) + "${l['text.percentage']}";
			}
		
    		return val.toFixed() + "${l['text.percentage']}";
  		};
	
	  	function percentageFormatter(val, axis) {
  			if (axis) {
		    	return (val * 100).toFixed(axis.tickDecimals) + "${l['text.percentage']}";
	    	}
		    
	    	return (val * 100).toFixed() + "${l['text.percentage']}";
  		};
	
	  	function KBformatter(val, axis) {
    		if (val > 1000) {
	    		if (axis) {
	      			return (val/1000).toFixed(axis.tickDecimals) + "${l['text.mb']}";
	      		}
		      	
	      		return (val/1000).toFixed(2) + "${l['text.mb']}";
    		} else {
	    		if (axis) {
	      			return val.toFixed(axis.tickDecimals) + "${l['text.kb']}";
	      		}
		      	
	      		return val.toFixed(2) + "${l['text.kb']}";
    		}
  		};
	
	  	function Bformatter(val, axis) {
	    	if (val > 1000000) {
    			if (axis) { 
		     		return (val/1000000).toFixed(axis.tickDecimals) + "${l['text.mb']}";
	     		}
		     	
	     		return (val/1000000).toFixed() + "${l['text.mb']}";
    		} else if (val > 1000) {
	    		if (axis) {
	     			return (val/1000).toFixed(axis.tickDecimals) + "${l['text.kb']}";
	     		}
		     	
	     		return (val/1000).toFixed() + "${l['text.kb']}";
    		} else {
	    		if (axis) { 
	     			return val.toFixed(axis.tickDecimals) + "${l['text.byte']}";
	     		}
		     	
	     		return val.toFixed() + "${l['text.byte']}";
    		}
  		};

  		function msformatter(val, axis) {
	    	if (val > 1000) {
    			if (axis) { 
			      	return (val/1000).toFixed(axis.tickDecimals) + "${l['text.second']}";
			    }
			    
			    return (val/1000).toFixed(0) + "${l['text.second']}";
    		} else {
    			if (axis) {
		      		return val.toFixed(axis.tickDecimals) + "${l['text.millisecond']}";
		    	}
		    	
			    return val.toFixed() + "${l['text.millisecond']}";
    		}
  		};
	  	
  		function getFormatter(units) {
    		if (typeof(units) != "undefined") {
      			if (units == "percent") {
        			return percentFormatter;
      			} else if (units == "percentage") {
        			return percentageFormatter;
      			} else if (units == "KB") {
        			return KBformatter;
      			} else if (units == "B") {
        			return  Bformatter;
      			} else if (units == "ms") {
        			return msformatter;
      			}
    		}
    	
    		return null;
  		};

		function timeFormatter(val, axis) {
			var timestamp = new Date(val);
			var range = jQuery("#rangeSelection").val();
		
			if (range <= 43200000) {
				return timestamp.format('h:MMt');
			} else if (range <= 172800000) {
				return timestamp.format('ddd, h:MMt');
			} else if (range <= 604800000) {
				return timestamp.format('ddd, m/d');
			}
		
			return timestamp.format('mmm dd');
		};
	
  		function getMax(unit) {
    		if (unit == "percent") {
      			return 100;
    		} else if (unit == "percentage") {
		      	return 1;
    		}
    
	    	return undefined;
  		};

	  	function getChartOptions(res) {
    		var y1units = res.y1units;
    		var y2units = res.y2units;
    		var y1max = getMax(y1units);
    		var y2max = getMax(y2units);
			var xMin = res.start;
			var xMax = res.end;
		
    		return {
      			lines:    {show: true},
      			points:   {show: false},
      			legend:   {show: true, position: "nw", labelBoxBorderColor: "#000000"},
      			yaxis:    {min: 0, max: y1max, labelWidth: 40, tickFormatter: getFormatter(y1units)},
      			y2axis:   {min: 0, max: y2max, labelWidth: 40, tickFormatter: getFormatter(y2units)},
      			xaxis:    {min: xMin, max: xMax, mode: "time", twelveHourClock: true, tickFormatter: timeFormatter },
      			grid:     {color: "#000000",
      	           			borderColor: "#ddd",
                   			hoverable: true,
                   			autoHighlight: true,
                   			backgroundColor: "#FFFAFF"}
    		};
  		};

  		function drawChart(id) {
    		var utcoffset = new Date().getTimezoneOffset() * 60000;
    		var metricVal = null;
    	
    		if (jQuery("#metricSelection").size() > 0) {
	    		metricVal = jQuery("#metricSelection").val();
	    	}
	    
	    	var rangeVal = jQuery("#rangeSelection").val();
    		var params = {
    			'mid': id,
    			'utcoffset': utcoffset,
    			'range': rangeVal
    		};
    	
	    	if (metricVal) {
    			params['compare'] = metricVal;
    		}
    	
    		jQuery.ajax({url: "/hqu/vsphere/performance/data.hqu",
    	    	       	data: params,
                		dataType: "json",
                		timeout: 60000,
						cache: false,
                		success: function(result) {
                   	 		jQuery.plot(jQuery("#chart" + id), result.data, getChartOptions(result));
                   		}
    		});
  		};

		function drawAvailability() {
			<% if (availabilityJSON) { %>
			jQuery.ajax({
				'url': '/hqu/vsphere/performance/availability.hqu',
				'data': {
					'mid': ${availMetric.id},
					'range': jQuery("#rangeSelection").val(),
					'utcoffset': new Date().getTimezoneOffset() * 60000
				},
				'timeout': 60000,
				'cache': false,
				'dataType': 'json',
				'success': function(data) {
					data['title'] = '${l['label.availability']}';
				
					jQuery('#availability').empty().healthcontrol(data);
				}
			});
			<% } %>
		};
	
  		function drawCharts() {
  			jQuery("span.lastUpdated").text("${l['text.last.updated']} " + (new Date()).format("longTime"));
  			
  			drawAvailability();
    			
    		<% for (metric in resourceMetrics) { %>
    			drawChart(${metric.id});
    		<% } %>
  		};

  		var resizeTimer = null;
  
  		jQuery(document).ready(function() {
  			var metric = jQuery.bbq.getState('m');
  			
  			if (metric) {
  				jQuery("#metricSelection").val(metric);
  			}
  		
    		jQuery("#metricSelection").change(function(event) {
    			var metric = jQuery(this).val();
    		
    			jQuery.bbq.pushState({ 'm': metric });
    		
    			drawCharts();
    		});
    	
    		var range = jQuery.bbq.getState('rg');
    	
    		if (range) {
    			jQuery("#rangeSelection").val(range);
    		}
    	
    		jQuery("#rangeSelection").change(function(event) {
    			drawCharts();
    		
    			var range = jQuery(this).val();
    		
    			jQuery.bbq.pushState({ 'rg': range });
    		});
    	
    		jQuery(window).bind('resize', function() {
      			if (resizeTimer) clearTimeout(resizeTimer);
      			// Resizing can be slow, wait 500ms before redrawing the charts.
      			resizeTimer = setTimeout(function() {
      				jQuery(".chartcontainer").empty();
      				
      				drawCharts();
      			}, 500);
    		});
    	
    		<% if (availabilityJSON) { %>
    			jQuery.fn.healthcontrol.formatTimestamp = function(date) {
    				return timeFormatter(date.getTime());
    			};    			
    		<% } %>
    	
    		drawCharts();
    	
    		function showTooltip(x, y, contents) {
    			var tooltip = jQuery("#tooltip");
	
				if (tooltip.size() == 0) {
					tooltip = jQuery('<div id="tooltip"></div>').css({
						position: 'absolute',
    	        		display: 'none',
        	    		border: '1px solid #fdd',
    	        		padding: '2px',
        	    		'background-color': '#fee',
            			opacity: 1,
            			'z-index': 10
					}).appendTo("body");
				}
			
        		tooltip.css({
	            	top: y + 5,
            		left: x + 5
	        	}).html(contents).show();
	    	};

		    var previousPoint = null;
    	
    		jQuery(".chartcontainer").bind("plothover", function (event, pos, item) {
				if (item) {
            	    if (previousPoint != item.datapoint) {
               		    previousPoint = item.datapoint;
                    
                   		var x = item.datapoint[0].toFixed(),
                        	y = item.datapoint[1].toFixed(2);
                    	var datetime = new Date(Number(x));
                    	var formatter = getFormatter(item.series.units);
	                    var value = (formatter) ? formatter(new Number(y)) : (new Number(y)).toFixed();
                    
		                showTooltip(item.pageX, item.pageY, item.series.label + ", " + value + " at " + datetime.format('ddd, mmm dd, h:MMt'));
        	       	}
	        	} else {
               		jQuery("#tooltip").fadeOut(200);
	         	   previousPoint = null;            
    	    	}
    		});
  		});
	</script>
<% } %>