<% import org.hyperic.hq.appdef.shared.AppdefEntityID %>

<div class="panelHeader">
	<div class="navLink">
		<% if (resource) { %>
			<a href="/resource/platform/Control.do?mode=view&eid=${(new AppdefEntityID(resource))}">${l.getFormattedMessage("link.goto.control.page", resource.name)}</a>
		<% } %>
	</div>
</div>
<% if (resource) { %>
	<div class="vm-action-container">
		<h2>${l.getFormattedMessage('text.vm.commands', resource.name)}</h2>
		<ul class="vm-action-list">
		<% for (action in actions) { 
		      if (action.toLowerCase() != 'standbyguest') {	%>
			<li class="vm-action vm-action-${action.toLowerCase()}">
				<a href="#" onclick="runControlAction(${resource.id}, '${resource.name}', '${action}'); return false;">${l['text.control.' + action.toLowerCase()]}</a>			
			</li>
		<% }} %>
		</ul>
		<div id="controlStatus" style="display:none;">
			<p>
				<span>${l['label.control.name']}</span>
				<span id="actionName"></span><br/>
				<span id="lblDescription" style="display:none;">${l['label.control.description']}</span>
				<span id="actionDescription"></span>
			</p>
			<p>
				<span>${l['label.control.status']}</span>
				<span id="actionStatus"></span>&nbsp;<span id="actionDuration"></span><br/><br/>
				<span id="lblMessage" style="display:none;">${l['label.control.message']}</span>
				<span id="actionMessage"></span>
			</p>
		</div>
  </div>
<% } else { %>
<div>${l['text.no.actions.available']}</div>
<% } %>
<div id="controldialog" title="${l['text.action.confirmation.title']}" style="display:none;">
	<p id="confirmationMsg">
		<span>${l.getFormattedMessage('text.confirmation', '<strong id="confActionName"></strong>', '<strong id="confResourceName"></strong>')}</span>
	</p>
	<p id="gatherArguments">
		<span>${l['label.enter.snapshot.name']}</span><br/>
		<input id="argsInput" type="text" style="width: 100%;" maxlength="80" />
	</p>
</div>
<script>
	jQuery(document).ready(function() {
    	jQuery('#controldialog').dialog({ 
    		draggable: false, 
    		resizable: false,
    		position: 'center',
    		modal: true, 
    		autoOpen: false
	    });
    	
    	var oldDialogOpen = jQuery.ui.dialog.prototype.open;
  		
  		jQuery.ui.dialog.prototype.open = function() {
    		var originalScrollTop = jQuery(window).scrollTop(),
        		result = oldDialogOpen.apply(this, arguments);
        		
		    jQuery(window).scrollTop(originalScrollTop);
  		};
  	});

	function updateControlStatus(data) {
		if (data) {
			var div = jQuery("#controlStatus");
			var className = "action-inprogress";
			var duration = "";
			var formatDuration = function(duration) {
				var txt = "${l['text.control.in.duration']}";
				
				return txt.replace("{0}", duration); 
			};
			
			if (data.status == 'Failed') {
				className = "action-failed";
				duration = formatDuration(data.duration / 1000);
			} else if (data.status == 'Completed') {
				className = "action-completed";
				duration = formatDuration(data.duration / 1000);
			}
	
			div.find("#actionName").empty().text(data.name);
			div.find("#actionDescription").empty();
			div.find("#lblDescription").hide();
			
			if (data.description) {
				div.find("#actionDescription").text(data.description);
				div.find("#lblDescription").show();
			}
			
			div.find("#actionStatus").removeClass().addClass(className).empty().text(data.status);
			div.find("#actionMessage").empty();
			div.find("#lblMessage").hide();
			
			if (data.message) {
				div.find("#actionMessage").text(data.message);
				div.find("#lblMessage").show();
			}
			
			div.find("#actionDuration").empty().text(duration);
			
			div.show();
		}
	};
	
	function checkControlActionStatus(resourceId, actionId) {
		jQuery.ajax({
			url: '/hqu/vsphere/vsphere/checkControlStatus.hqu',
			data: {
				'id': resourceId,
				'aid': actionId
			},
			timeout: 60000,
			cache: false,
			success: function(data) {
				var payload = data.payload;
				
				if (payload) {
					if (payload.status.toLowerCase() == 'in progress') {
						jQuery("#controlStatus").oneTime("3s", function() {
							checkControlActionStatus(resourceId, actionId);
						});
					} else {
						updateControlStatus(payload);
					}
				}
			}
		});
	}
	
	function runControlAction(id, name, action) {
		if (action == 'createSnapshot') {
			jQuery('#confirmationMsg').hide();
			jQuery('#gatherArguments').show();			
		} else {
			jQuery('#confirmationMsg').show();
			jQuery('#gatherArguments').hide();			
		}
		
		jQuery('#argsInput').val('');
		jQuery('#confActionName').text(action);
    	jQuery('#confResourceName').text(name);
    	jQuery('#controldialog').dialog('option', 'buttons', {
	   		"${l['button.cancel']}": function(event) {
   				jQuery(this).dialog('close');
   			},
    		"${l['button.execute']}": function(event) {
    			var input = jQuery('#argsInput');
    			var args = '';

				if (input.is(':visible') && input.val() == '') {
					input.focus();
					
					return;
				} else {
					args = input.val().replace(/ /g, "_");
				}

   				var params = {
					'id': id,
					'action': action,
					'args': args
				};
		
				updateControlStatus({ name: action });
		
				var startTime = (new Date()).getTime();
			
				jQuery.ajax({
					url: '/hqu/vsphere/vsphere/executeControlAction.hqu',
					data: params,
					timeout: 60000,
					cache: false,
					success: function(data) {
						if (data.success) {
							var payload = data.payload;
					
							updateControlStatus(payload);
					
							if (payload && payload.status.toLowerCase() == 'in progress') {
								jQuery("#controlStatus").oneTime("3s", function() {
									checkControlActionStatus(id, payload.id);
								});
							}
						} else {
							alert(data.error);			
						}
					},
					error: function(xhr, status) {
						updateControlStatus({ name: action, status: 'Failed', duration: ((new Date()).getTime() - startTime), message: status });
					}
				});
			
				jQuery(this).dialog('close');
    		}
   		});
    	jQuery('#controldialog').dialog('open');
    	jQuery('#argsInput').focus();
	};
</script>